import 'package:bloc_stream/bloc_stream.dart';
import 'package:test/test.dart';

class CounterActions {
  static final BlocStreamAction<int, CounterBloc> increment =
      (currentValue, bloc, c) async => c.add(currentValue + 1);

  static final BlocStreamAction<int, CounterBloc> decrement =
      (currentValue, bloc, c) async => c.add(currentValue - 1);
}

class CounterBloc extends BlocStream<int> {
  CounterBloc() : super(0);
}

void main() {
  group('CounterBloc', () {
    test('increments and decrements correctly', () {
      final counter = CounterBloc();
      assert(counter.value == 0);
      counter.add(CounterActions.increment);
      assert(counter.value == 1);
      counter.add(CounterActions.decrement);
      assert(counter.value == 0);
    });
  });
}
